freeslot("MT_SNOWBALL")
addHook("PlayerThink", function(player)
	if(player.mo.frozen)
		return true
   elseif(player.cmd.buttons & BT_CUSTOM3 and player.bot == 0)
    if(not player.mo.thokk)
		player.mo.oldf = player.mo.flags
		player.mo.flags = $1 & MF_NOTHINK
		player.mo.ball = P_SpawnPlayerMissile(player.mo, MT_SNOWBALL)
		if(player.mo.ball and player.mo.ball.valid)
			player.mo.ball.angle = player.mo.angle
			P_TeleportMove(player.mo.ball, player.mo.x + player.mo.momx + FixedMul(40*FRACUNIT, cos(player.mo.angle)), player.mo.y + player.mo.momy + FixedMul(40*FRACUNIT, sin(player.mo.angle)), player.mo.z + player.mo.height/2 + 20*FRACUNIT)
			player.mo.ball.fotimer = 35
		end
		player.mo.flags = player.mo.oldf
	end -- not thokk end
		player.mo.thokk = true
	else
		player.mo.thokk = false
	end
end)

addHook("MobjMoveCollide", function(bullet, mobj)
  if not (bullet.type == MT_SNOWBALL) return end
  if(mobj and bullet and bullet.z <= mobj.z + mobj.height and bullet.z+bullet.height >= mobj.z)
	if(mobj.type == MT_PLAYER and mobj.ball)
		P_InstaThrust(bullet, bullet.angle, 60*FRACUNIT)
	else
	   if not (mobj.oldc) -- if oldcolor does not exist
		 mobj.oldc = mobj.color
	   end
	   if not (mobj.oldf) -- if oldflags do not exist
		if(mobj.type == MT_PLAYER)-- Mobj is player.mo
			mobj.oldpf = mobj.pflags
		end
		mobj.oldf = mobj.flags
		end 
		mobj.frozen = true
		mobj.frozent = 175 -- freeze timer
		S_StartSound(mobj, sfx_s3kces)
		mobj.colorized = true
		mobj.color = SKINCOLOR_ICY
		mobj.flags = MF_SOLID|MF_PUSHABLE|MF_NOGRAVITY
		if(mobj.type == MT_PLAYER)-- Mobj is player.mo
		 mobj.player.powers[pw_nocontrol] = 1
		 mobj.pflags = PF_FULLSTASIS
		end -- What is mobj end
	end -- If we hit ourselves end
  end -- Collision end
end)

addHook("MobjThinker", function(mobj)
 if(mobj.frozen)
  if(mobj.frozent)
   mobj.frozent = $1 - 1
  else
   mobj.frozen = false
   mobj.flags = mobj.oldf
   if(mobj.oldpf) 
	 mobj.pflags = mobj.oldf 
	 mobj.player.powers[pw_nocontrol] = 0
	end
   mobj.color = mobj.oldc
   mobj.colorized = false
   S_StartSound(mobj, sfx_shattr)
   mobj.momx = 0
   mobj.momy = 0
  end -- frozen timer end
  return true
 end--frozen end
 if(mobj.valid and mobj.type == MT_SNOWBALL)
  if(mobj.fotimer)
   mobj.fotimer = $1 - 1
  else
   P_RemoveMobj(mobj)
   return
  end
 end--snowball thinker 
end)
